> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-transactions/network/fetchnonce.md).

# fetchNonce

Looks up the next nonce for an address from a Stacks node.

***

### Usage

```ts
import { fetchNonce } from '@stacks/transactions';

const nonce = await fetchNonce({
  address: 'ST1PQHQKV0RJXZFY1DGX8MNSNYVE3VGZJSRTPGZGM',
  network: 'testnet',
});

console.log(nonce); // e.g. 42n
```

#### Notes

* Returns a `bigint` representing the next nonce for the address.
* The builder functions (`makeSTXTokenTransfer`, `makeContractCall`, etc.) call this automatically when `nonce` is not provided.
* Tries the Hiro API's `/extended/v1/address/{address}/nonces` endpoint first, then falls back to the core node's `/v2/accounts/{address}` endpoint.

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/transactions/src/fetch.ts#L99)

***

### Signature

```ts
function fetchNonce(opts: {
  address: string;
} & NetworkClientParam): Promise<bigint>;
```

***

### Returns

`Promise<bigint>`

A promise that resolves to the next nonce for the address.

***

### Parameters

#### opts.address (required)

* **Type**: `string`

The Stacks address to look up the next nonce for.

#### opts.network (optional)

* **Type**: `StacksNetworkName | StacksNetwork`

The network to query. Defaults to `'mainnet'`.

#### opts.client (optional)

* **Type**: `NetworkClient`

Custom client configuration for the API call.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-transactions/network/fetchnonce.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
